/*********************************************************************
 *
 * UUSB.C
 *
 * nnc4hdus̃\[XpĂ܂̂Ő͂ɏ]ĉB
 *
 **********************************************************************/


/*
 *
 */
#include <WINDOWS.H>
#include <SETUPAPI.H>
#include <TCHAR.H>
#include <DDK/USB.H>


/*--------------------------------------------------------------------
 * UUSBDIOCTL
 *--------------------------------------------------------------------*/


/*
 *
 */
#define UUSBD_IOCTL_INDEX    0x0000


/*
 *
 */
#define IOCTL_UUSBD_VENDORREQUEST_IN    CTL_CODE(FILE_DEVICE_UNKNOWN,   \
                                                 UUSBD_IOCTL_INDEX + 3, \
                                                 METHOD_BUFFERED,       \
                                                 FILE_ANY_ACCESS)


/*
 *
 */
typedef struct tagPARAM_VENDOR_REQUEST {
    IN USHORT Function;
    IN ULONG  TransferFlags;    /* w蒷ۂ̓]ZĂG[ƂȂꍇUSBD_SHORT_TRANSFER_OKw */
    IN UCHAR  ReservedBits;
    IN UCHAR  Request;
    IN USHORT Value;
    IN USHORT Index;
} PARAM_VENDOR_REQUEST;


/*--------------------------------------------------------------------
 * ^̒`
 *--------------------------------------------------------------------*/


/*
 * foCXǗ\
 */
typedef struct {
    HANDLE Device;
    TCHAR  Name[MAX_PATH];
} UUSB_DEVICE;


/*--------------------------------------------------------------------
 * O[oϐ̒`
 *--------------------------------------------------------------------*/


/*
 * {69910468-8802-11d3-ABC7-A756B2FDFB29} for UUSBD.SYS
 */
GUID GUID_CLASS_UUSBD = {
    0x69910468,
    0x8802,
    0x11D3,
    { 0xAB, 0xC7, 0xA7, 0x56, 0xB2, 0xFD, 0xFB, 0x29 }
};


/*--------------------------------------------------------------------
 * ėp֐̒`
 *--------------------------------------------------------------------*/


/*
 * w肵GUIDnԖڂ̃foCX̖O擾
 */
BOOL GetDeviceName(HDEVINFO hDevInfo, LPGUID lpGuid, DWORD dwIndex, TCHAR *lpName)
{
    BOOL                            bResult;
    DWORD                           dwError;
    DWORD                           dwLength;
    SP_INTERFACE_DEVICE_DATA        nData;
    SP_INTERFACE_DEVICE_DETAIL_DATA *lpDetail;

    bResult      = FALSE;
    nData.cbSize = sizeof(SP_INTERFACE_DEVICE_DATA);
    if (SetupDiEnumDeviceInterfaces(hDevInfo, 0, lpGuid, dwIndex, &nData)) {
        SetupDiGetDeviceInterfaceDetail(hDevInfo, &nData, NULL, 0, &dwLength, NULL);
        dwError = GetLastError();
        if (dwError == ERROR_INSUFFICIENT_BUFFER) {
            lpDetail = AllocMemory(dwLength);
            if (lpDetail) {
                lpDetail->cbSize = sizeof(SP_INTERFACE_DEVICE_DETAIL_DATA);
                if (SetupDiGetInterfaceDeviceDetail(hDevInfo, &nData, lpDetail, dwLength, NULL, NULL)) {
                    _tcscpy(lpName, lpDetail->DevicePath);
                    bResult = TRUE;
                }
                FreeMemory(lpDetail);
            }
        }
    }
    return(bResult);
}


/*--------------------------------------------------------------------
 * ֐̒`
 *--------------------------------------------------------------------*/


/*
 * Ǘ̈̊J
 */
void UUSB_Delete(HANDLE hUUSB)
{
    UUSB_DEVICE *lpUUSB;

    if (hUUSB == 0) {
        return;
    }
    lpUUSB = (UUSB_DEVICE *) hUUSB;
    CloseHandle(lpUUSB->Device);
    FreeMemory(lpUUSB);
}


/*
 * Ǘ̈̊m
 */
HANDLE UUSB_Create(void)
{
    UUSB_DEVICE *lpUUSB;

    lpUUSB = AllocMemory(sizeof(UUSB_DEVICE));
    if (lpUUSB == 0) {
        return(0);
    }
    ZeroMemory(lpUUSB, sizeof(UUSB_DEVICE));
    lpUUSB->Device = INVALID_HANDLE_VALUE;
    return((HANDLE) lpUUSB);
}


/*
 * foCX
 */
void UUSB_Close(HANDLE hUUSB)
{
    UUSB_DEVICE *lpUUSB;

    if (hUUSB == 0) {
        return;
    }
    lpUUSB = (UUSB_DEVICE *) hUUSB;
    CloseHandle(lpUUSB->Device);
    lpUUSB->Device = INVALID_HANDLE_VALUE;
}


/*
 * foCXJ
 */
BOOL UUSB_Open(HANDLE hUUSB, WORD wVender, WORD wProduct)
{
    BOOL        bResult;
    DWORD       dwIndex;
    HDEVINFO    hDevInfo;
    LPGUID      lpGuid;
    UUSB_DEVICE *lpUUSB;

    if (hUUSB == 0) {
        return(FALSE);
    }
    lpUUSB = (UUSB_DEVICE *) hUUSB;
    UUSB_Close(hUUSB);
    bResult  = FALSE;
    lpGuid   = (LPGUID) &GUID_CLASS_UUSBD;
    hDevInfo = SetupDiGetClassDevs(lpGuid, NULL, NULL, (DIGCF_PRESENT | DIGCF_INTERFACEDEVICE));
    if (hDevInfo != INVALID_HANDLE_VALUE) {
        dwIndex = 0;
        while (GetDeviceName(hDevInfo, lpGuid, dwIndex, lpUUSB->Name)) {
            if ((_tcstoul(lpUUSB->Name + 12, 0, 16) == wVender) && (_tcstoul(lpUUSB->Name + 21, 0, 16) == wProduct)) {
                lpUUSB->Device = CreateFile(lpUUSB->Name, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL);
                if (lpUUSB->Device != INVALID_HANDLE_VALUE) {
                    bResult = TRUE;
                    break;
                }
                CloseHandle(lpUUSB->Device);
            }
            dwIndex++;
        }
        SetupDiDestroyDeviceInfoList(hDevInfo);
    }
    return(bResult);
}


/*
 * pCvJ
 */
HANDLE UUSB_OpenPipe(HANDLE hUUSB, WORD wFace, WORD wPipe)
{
    UUSB_DEVICE *lpUUSB;
    TCHAR       nName[MAX_PATH + 100];

    if (hUUSB == 0) {
        return(INVALID_HANDLE_VALUE);
    }
    lpUUSB = (UUSB_DEVICE *) hUUSB;
    _stprintf(nName, "%s\\if%03dpipe%03d", lpUUSB->Name, wFace, wPipe);
    return(CreateFile(nName, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, NULL));
}


/*
 * x_[NGXg
 */
BOOL UUSB_VendorRequest(HANDLE hUUSB, BYTE bRequest, WORD wValue, WORD wIndex, WORD wSize, char *lpData)
{
    DWORD                temp;
    HANDLE               hDevice;
    PARAM_VENDOR_REQUEST pvr;
    UUSB_DEVICE          *lpUUSB;

    if (hUUSB == 0) {
        return(FALSE);
    }
    lpUUSB  = (UUSB_DEVICE *) hUUSB;
    hDevice = lpUUSB->Device;
    if (hDevice == INVALID_HANDLE_VALUE) {
        return(FALSE);
    }
    pvr.Function      = URB_FUNCTION_VENDOR_DEVICE;
    pvr.TransferFlags = USBD_SHORT_TRANSFER_OK;
    pvr.ReservedBits  = 0;
    pvr.Request       = bRequest;
    pvr.Value         = wValue;
    pvr.Index         = wIndex;
    return(DeviceIoControl(hDevice, IOCTL_UUSBD_VENDORREQUEST_IN, &pvr, sizeof(pvr), lpData, wSize, &temp, NULL));
}
